property GRIDXORIGIN, GRIDYORIGIN, CELLWIDTH, CELLHEIGHT, COLS, ROWS, VCELLGAP, HCELLGAP, CURR_CELL

on birth me, XOrigin, YOrigin, CellW, CellH, Columns, Roes, VCGap, HCGap
  set GRIDXORIGIN to XOrigin
  set GRIDYORIGIN to YOrigin
  set CELLWIDTH to CellW
  set CELLHEIGHT to CellH
  set COLS to Columns
  set ROWS to Roes
  set VCELLGAP to VCGap
  set HCELLGAP to HCGap
  set CURR_CELL to 0
  return me
end

on getCellRects me
  set i to 1
  set returnList to []
  repeat with theRows = 1 to ROWS
    set x1 to GRIDXORIGIN
    set x2 to x1 + CELLWIDTH
    set y1 to GRIDYORIGIN + ((CELLHEIGHT + VCELLGAP) * (theRows - 1))
    set y2 to y1 + CELLHEIGHT
    repeat with theCols = 1 to COLS
      set tempRect to rect(x1, y1, x2, y2)
      addAt(returnList, i, tempRect)
      set x1 to x2 + HCELLGAP
      set x2 to x1 + CELLWIDTH
      set i to i + 1
    end repeat
  end repeat
  return returnList
end

on CellRectFromPt me, h, v, checkBounds
  if checkBounds = 1 then
    if chkBnds(me, h, v) = 0 then
      set CURR_CELL to 0
      return []
    end if
  end if
  repeat with theRows = 1 to ROWS
    set x1 to GRIDXORIGIN
    set x2 to x1 + CELLWIDTH
    set y1 to GRIDYORIGIN + ((CELLHEIGHT + VCELLGAP) * (theRows - 1))
    set y2 to y1 + CELLHEIGHT
    if v <= y2 then
      if v < y1 then
        set CURR_CELL to 0
        return []
        next repeat
      end if
      repeat with theCols = 1 to COLS
        if h <= x2 then
          if h < x1 then
            set CURR_CELL to 0
            return []
          else
            set CURR_CELL to ((theRows - 1) * COLS) + theCols
            return rect(x1, y1, x2, y2)
          end if
        end if
        set x1 to x2 + HCELLGAP
        set x2 to x1 + CELLWIDTH
      end repeat
    end if
  end repeat
  set CURR_CELL to 0
  return []
end

on cellNumToRect me, whichCell
  if whichCell = 0 then
    return []
  else
    set row to cellToRow(me, whichCell)
    set column to cellToCol(me, whichCell)
    set x1 to GRIDXORIGIN + (CELLWIDTH * (column - 1)) + (HCELLGAP * (column - 1))
    set x2 to x1 + CELLWIDTH
    set y1 to GRIDYORIGIN + (CELLHEIGHT * (row - 1)) + (VCELLGAP * (row - 1))
    set y2 to y1 + CELLHEIGHT
    return rect(x1, y1, x2, y2)
  end if
end

on cellToRow me, whichCell
  repeat with theRow = 1 to ROWS
    if whichCell <= (COLS * theRow) then
      exit repeat
    end if
  end repeat
  return theRow
end

on cellToCol me, whichCell
  set column to whichCell mod COLS
  if column = 0 then
    set column to COLS
  end if
  return column
end

on chkBnds me, h, v
  set ret to 0
  if h >= GRIDXORIGIN then
    if h <= (GRIDXORIGIN + ((COLS * CELLWIDTH) + (HCELLGAP * (COLS - 1)))) then
      if v >= GRIDYORIGIN then
        if v <= (GRIDYORIGIN + ((ROWS * CELLHEIGHT) + (VCELLGAP * (ROWS - 1)))) then
          set ret to 1
        end if
      end if
    end if
  end if
  return ret
end
